/*
 * fsarchiver: Filesystem Archiver
 *
 * Copyright (C) 2008-2009 Francois Dupoux.  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License v2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * Homepage: http://www.fsarchiver.org
 */

#ifndef __CREATE_H__
#define __CREATE_H__

struct s_filesysdat;
struct s_archive;
struct s_regmulti;
struct s_dico;
struct s_dichl;
struct stat64;

int backup_obj_regfile_unique(struct s_archive *ai, struct s_dico *header, char *relpath, char *fullpath, u64 filesize, u16 fsid);
int backup_obj_regfile_multi(struct s_archive *ai, struct s_dico *header, char *relpath, char *fullpath, u64 filesize, u16 fsid, struct s_regmulti *m);
int backup_item_stdattr(struct s_archive *ai, char *root, char *relpath, struct stat64 *statbuf, 
		struct s_dico *d, int *objtype, struct s_filesysdat *fsdat, u64 objectid);
int backup_item_xattr(struct s_archive *ai, char *root, char *relpath, struct stat64 *statbuf, struct s_dico *d);
int filesystem_mount_partition(struct s_dico *dicofs, char *partition, char *partmnt, int *fstype, u16 fsid, bool *mntbyfsa);
int filesystem_save(struct s_archive *ai, char *partition, char *partmount, u16 fsid, int fstype, bool mountedbyfsa);
int do_create(char *archive, char **partition, int archtype);
int write_mainhead(struct s_archive *ai, char *label);
int backup_file(struct s_archive *ai, char *root, char *relpath, struct stat64 *statbuf, struct s_filesysdat *fsdat, u64 objectid);

#endif // __CREATE_H__
