/*
 * fsarchiver: Filesystem Archiver
 *
 * Copyright (C) 2008-2009 Francois Dupoux.  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License v2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * Homepage: http://www.fsarchiver.org
 */

#ifndef __STRLIST_H__
#define __STRLIST_H__

struct s_strlistitem
{
	char			*str;
	struct s_strlistitem	*next;
};

struct s_strlist { struct s_strlistitem *head; };

struct s_strlist *strlist_alloc(); // dynamic creation
int	strlist_destroy(struct s_strlist *l); // dynamic destruction
int	strlist_init(struct s_strlist *l); // static initialization
int	strlist_empty(struct s_strlist *l);
int	strlist_add(struct s_strlist *l, char *str);
int	strlist_remove(struct s_strlist *l, char *str);
int	strlist_exists(struct s_strlist *l, char *str);
int	strlist_getitem(struct s_strlist *l, int index, char *buf, int bufsize);
char	*strlist_merge(struct s_strlist *l, char *bufdat, int bufsize, char sep);
int	strlist_split(struct s_strlist *l, char *text, char sep);
int	strlist_count(struct s_strlist *l);
int	strlist_show(struct s_strlist *l);

#endif // __STRLIST_H__
